Astron Coding Style Guidelines
------------------------------
Code and documentation in the master & release branches should conform to Astron's style guidelines.
This means that code should be formatted properly before being submitted in a pull request.
Naturally, it is ideal to keep a consistent style even before making a pull request.
Additionally, like all style guides, don't blindly follow the guide into making code unreadable.

**Common Conventions**  
- All files should use spaces instead of tabs.
- All files should end with a newline.
- Lines should not have trailing whitespace (except where part of the syntax, like in markdown).

**Python**  
For python use PEP-8 style guidelines.

**C/C++**  
For C and C++ code refer to the [C++ Style Guide](cxx-style.md).

**CMake**  
For CMake scripts refer to the [CMake Style Guide](cmake-style.md).
